/* as_proto.h - Function prototypes.
*/

#ifndef H_AS_PROTO
#define H_AS_PROTO


#ifdef POSIX_PROTOTYPES

/* From file 'as_util.c'... */

extern	void	as_print_greeting (void);
extern	void	as_print_parting (void);
extern	bool	as_read_input (string buf, bool echo_input);
extern	void	as_process_input (string buf);
extern	void	as_respond (as_node str_list, string main_str, string sub_str);
extern	int	as_format_output (string buf, as_node listp, string main_str, string sub_str, int last_idx);
extern	void	as_ptbl_init (string fname);
extern	void	as_ptbl_free (void);
extern	void	as_make_new_main_node (string main_str, file fp, string fname);
extern	as_node	as_make_new_response_list (string inbuf, file fp, string fname, char end_char);
extern	void	as_sprintf (string dest, string src);
extern	string	as_char_name (int num);

/* From file 'as_list.c'... */

extern	void	as_add_node (as_node nd, as_node hd);
extern	void	as_add_strnode (as_str_node nd, as_str_node hd);
extern	as_node	as_str_in_list (string str, as_node hd, bool allow_dflt);
extern	as_str_node	as_str_in_strlist (string str, as_str_node hd, bool allow_dflt);
extern	int	as_rand_idx (as_node hd);
extern	as_node	as_node_at_idx (int idx, as_node hd);
extern	as_str_node	as_str_node_at_idx (int idx, as_str_node hd);
extern	void	as_list_free (as_node hd);
extern	void	as_strlist_free (as_str_node hd);
extern	as_node as_list_find_default (as_node hd);

#ifdef DEBUGGING_MODE
extern	void	as_debug_print_list (as_node hd, int indent_spaces);
extern	void	as_debug_print_strlist (as_str_node hd, int indent_spaces);
#endif

/* From file 'as_general.c'... */

extern	string	strtrim (string str);
extern	string	strupper (string str);
extern	void	str2array (string str, string delims, bool usedelims, string substrs[]);

#else	/* no POSIX_PROTOTYPES */

/* From file 'as_util.c'... */

extern	void	as_print_greeting ();
extern	void	as_print_parting ();
extern	bool	as_read_input ();
extern	void	as_process_input ();
extern	void	as_respond ();
extern	int	as_format_output ();
extern	void	as_ptbl_init ();
extern	void	as_ptbl_free ();
extern	void	as_make_new_main_node ();
extern	as_node	as_make_new_response_list ();
extern	void	as_sprintf ();
extern	string	as_char_name ();

/* From file 'as_list.c'... */

extern	void	as_add_node ();
extern	void	as_add_strnode ();
extern	as_node	as_str_in_list ();
extern	as_str_node	as_str_in_strlist ();
extern	int	as_rand_idx ();
extern	as_node	as_node_at_idx ();
extern	as_str_node	as_str_node_at_idx ();
extern	void	as_list_free ();
extern	void	as_strlist_free ();
extern	as_node as_list_find_default ();

#ifdef DEBUGGING_MODE
extern	void	as_debug_print_list ();
extern	void	as_debug_print_strlist ();
#endif

/* From file 'as_general.c'... */

extern	string	strtrim ();
extern	string	strupper ();
extern	void	str2array ();

#endif	/* POSIX_PROTOTYPES */

#endif

